package com.fp.persistence.pgeneral.trans;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;

import com.fp.dto.hb.Cache;
import com.fp.dto.hb.HibernateBean;
import javax.persistence.Version;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENETRANSACTIONFINANPROCESS*/
@Entity(name="TgeneTransactionFinanProcess")
@Table(name="TGENETRANSACTIONFINANPROCESS")
public class TgeneTransactionFinanProcess extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable,Cache{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneTransactionFinanProcess
*/
@EmbeddedId
private TgeneTransactionFinanProcessKey pk;
@Column(name="PROCESSCODE", nullable=true)

/**
* Paquete clase de un comando a ejecutar.
*/
private String processcode;

@Column(name="CATALOGTYPEPROCESS", nullable=true)

/**
* Codigo de catalogo  GEN proceso general consulta, mantenimiento, TRA a nivel de transaccion finacniera, ITEM a niveld e rubro de una trnsaccion financiera, BATH comandos de fin de dia
*/
private String catalogtypeprocess;

@Column(name="CATALOGCODETYPEPROCESS", nullable=true)

/**
* Codigo de tabla de catalogo del proceso de negocio de la aplicacion
*/
private String catalogcodetypeprocess;

@Version
@Column(name="RECORDVERSION", nullable=true)

/**
* Optimistic locking del registro
*/
private Integer recordversion;

@Column(name="EVENT", nullable=false)

/**
* Proceso de negocio a ejecuatr en B (Begin)  inicio de la transaccion, P (Process) proceso de la transaccion, E (End)  Fin de la transaccion
*/
private String event;

@Column(name="EXECUTIONORDER", nullable=false)

/**
* Orden de ejecucion del comando.
*/
private Integer executionorder;

@Column(name="STATUS", nullable=true)

/**
* A indica que la regla esta activa, I regla Inactiva
*/
private String status;

@Column(name="MANAGECACHE", nullable=true)

/**
* Indica si el registro se almacena en cache del servidor de aplicaicones
*/
private String managecache;

/**Contructor por defecto*/
public TgeneTransactionFinanProcess(){
}
/**Contructor de TgeneTransactionFinanProcess
@param pPk Clave Primaria del entity
@param pEvent Proceso de negocio a ejecuatr en B (Begin)  inicio de la transaccion, P (Process) proceso de la transaccion, E (End)  Fin de la transaccion
@param pExecutionorder Orden de ejecucion del comando.
*/
public TgeneTransactionFinanProcess(TgeneTransactionFinanProcessKey pPk,String pEvent,Integer pExecutionorder){
 this();
 pk=pPk;
 event=pEvent;
 executionorder=pExecutionorder;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneTransactionFinanProcess
*/
public static TgeneTransactionFinanProcess find(EntityManager pEntityManager,TgeneTransactionFinanProcessKey pKey) throws Exception{
    TgeneTransactionFinanProcess obj = pEntityManager.find(TgeneTransactionFinanProcess.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneTransactionFinanProcess
@return El objeto que referencia a la Clave primaria de TgeneTransactionFinanProcess
*/
public TgeneTransactionFinanProcessKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneTransactionFinanProcess
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneTransactionFinanProcess
*/
public void setPk(TgeneTransactionFinanProcessKey pPk){
  pk=pPk;
}
/**Obtiene el valor de processcode
@return valor de processcode*/
public String getProcesscode(){
  return processcode;
}
/**Fija el valor de processcode
@param pProcesscode nuevo Valor de processcode*/
public void setProcesscode(String pProcesscode){
  processcode=pProcesscode;
}

/**Obtiene el valor de catalogtypeprocess
@return valor de catalogtypeprocess*/
public String getCatalogtypeprocess(){
  return catalogtypeprocess;
}
/**Fija el valor de catalogtypeprocess
@param pCatalogtypeprocess nuevo Valor de catalogtypeprocess*/
public void setCatalogtypeprocess(String pCatalogtypeprocess){
  catalogtypeprocess=pCatalogtypeprocess;
}

/**Obtiene el valor de catalogcodetypeprocess
@return valor de catalogcodetypeprocess*/
public String getCatalogcodetypeprocess(){
  return catalogcodetypeprocess;
}
/**Fija el valor de catalogcodetypeprocess
@param pCatalogcodetypeprocess nuevo Valor de catalogcodetypeprocess*/
public void setCatalogcodetypeprocess(String pCatalogcodetypeprocess){
  catalogcodetypeprocess=pCatalogcodetypeprocess;
}

/**Obtiene el valor de recordversion
@return valor de recordversion*/
public Integer getRecordversion(){
  return recordversion;
}
/**Fija el valor de recordversion
@param pRecordversion nuevo Valor de recordversion*/
public void setRecordversion(Integer pRecordversion){
  recordversion=pRecordversion;
}

/**Obtiene el valor de event
@return valor de event*/
public String getEvent(){
  return event;
}
/**Fija el valor de event
@param pEvent nuevo Valor de event*/
public void setEvent(String pEvent){
  event=pEvent;
}

/**Obtiene el valor de executionorder
@return valor de executionorder*/
public Integer getExecutionorder(){
  return executionorder;
}
/**Fija el valor de executionorder
@param pExecutionorder nuevo Valor de executionorder*/
public void setExecutionorder(Integer pExecutionorder){
  executionorder=pExecutionorder;
}

/**Obtiene el valor de status
@return valor de status*/
public String getStatus(){
  return status;
}
/**Fija el valor de status
@param pStatus nuevo Valor de status*/
public void setStatus(String pStatus){
  status=pStatus;
}

/**Obtiene el valor de managecache
@return valor de managecache*/
public String getManagecache(){
  return managecache;
}
/**Fija el valor de managecache
@param pManagecache nuevo Valor de managecache*/
public void setManagecache(String pManagecache){
  managecache=pManagecache;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneTransactionFinanProcess))return false;
    TgeneTransactionFinanProcess that = (TgeneTransactionFinanProcess) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneTransactionFinanProcess
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneTransactionFinanProcess
*/
public Object createInstance(){
 TgeneTransactionFinanProcess instance=new TgeneTransactionFinanProcess();	
 instance.setPk(new TgeneTransactionFinanProcessKey());
 return instance;
}
/**Clona la entidad TgeneTransactionFinanProcess
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneTransactionFinanProcess p=(TgeneTransactionFinanProcess)this.clone();
  p.setPk((TgeneTransactionFinanProcessKey)this.pk.cloneMe());
  return p;
}
}
